<?php

/* * ********************************************************************
  Copyright (C) FrontAccounting, LLC.
  Released under the terms of the GNU General Public License, GPL,
  as published by the Free Software Foundation, either version 3
  of the License, or (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the License here <http://www.gnu.org/licenses/gpl-3.0.html>.
 * ********************************************************************* */
$page_security = 'SA_BANKREP';
// ----------------------------------------------------------------
// $ Revision:	2.3.3-1
// Creator:	Chaitanya-India <3chaitanya@gmail.com>
// date_:	2005-05-19
// Title:	Bank Statements w/Reconcile
// Desc:	Bank Statement w/ Reconcile like the normal Bank Statement but with reconcile columns
// ----------------------------------------------------------------
$path_to_root = "..";

include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/includes/date_functions.inc");
include_once($path_to_root . "/includes/data_checks.inc");
include_once($path_to_root . "/gl/includes/gl_db.inc");
include_once($path_to_root . "/includes/ui/ui_input.inc");

//----------------------------------------------------------------------------------------------------

print_bank_transactions_reconcile();

//----------------------------------------------------------------------------------------------------

function get_bank_balance_to($to, $account) {
    $to = date2sql($to);
    $sql = "SELECT SUM(amount) FROM " . TB_PREF . "bank_trans WHERE bank_act='$account'
	AND trans_date < '$to'";
    $result = db_query($sql, "The starting balance on hand could not be calculated");
    $row = db_fetch_row($result);
    return $row[0];
}

function get_bank_transactions($from, $account) {
    $from = date2sql($from);
    $sql = "SELECT trans.*, com.memo_
			FROM "
            . TB_PREF . "bank_trans trans
				LEFT JOIN " . TB_PREF . "comments com ON trans.type = com.type AND trans.trans_no = com.id
		WHERE trans.bank_act = '$account'
		AND reconciled IS NULL 
		AND trans_date <= '$from' 
                AND trans.amount!=0
		ORDER BY trans_date,trans.id";
    return db_query($sql, "The transactions for '$account' could not be retrieved");
}

function print_bank_transactions_reconcile() {
    global $path_to_root, $systypes_array;

    $acc = $_POST['PARAM_0'];
    $from = $_POST['PARAM_1'];
    $destination = $_POST['PARAM_2'];
    $beg_balance = ($_POST['PARAM_3']);
    $end_balance = ($_POST['PARAM_4']);
    if ($destination)
        include_once($path_to_root . "/reporting/includes/excel_report.inc");
    else
        include_once($path_to_root . "/reporting/includes/pdf_report.inc");

    $rep = new FrontReport(_('Bank Reconciliation'), "BankStatementReconcile", user_pagesize(), 9, "L");
    $dec = user_price_dec();

    $cols = array(0, 90, 120, 170, 225, 450, 660, 700);

    $aligns = array('left', 'left', 'left', 'left', 'left', 'right', 'right', 'right', 'center', 'left');

    $headers = array(_('Type'), _('#'), _('Reference'), _('Date'), _('Person/Item'),
        _('Amount'), _('Narration'));

    $account = get_bank_account($acc);
    $act = $account['bank_account_name'] . " - " . $account['bank_curr_code'] . " - " . $account['bank_account_number'];
    $params = array(0 => '',
        1 => array('text' => _('Period'), 'from' => $from, 'to' => ''),
        2 => array('text' => _('Bank Account'), 'from' => $act, 'to' => ''));

    $rep->Font();
    $rep->Info($params, $cols, $headers, $aligns);
    $rep->NewPage();


    $book_balance = get_bank_balance_to(add_days($from,1), $account["id"]);

    $trans = get_bank_transactions($from, $account['id']);

    $rows = db_num_rows($trans);
    if ($book_balance != 0.0 || $rows != 0) {

        $date = date2sql($from);
        $reconciled = $end_balance;
        $rep->Font('bold');
        $rep->TextCol(0, 3, $act);
        $rep->TextCol(3, 5, _('Bank balance'));
        $rep->AmountCol(5, 6, $reconciled, $dec);
        $rep->Font();
        $rep->NewLine(2);
        // Keep a running total as we loop through
        // the transactions.
        $total_debit = $total_credit = 0;

        $deposit_on_transit = Array();
        if ($rows > 0) {

            $rep->Line($rep->row);
            $rep->Font('bold');
            $rep->TextCol(0, 7, _('Less: Checks outstanding'));
            $rep->Line($rep->row + 15);
            $rep->NewLine(2);
            $rep->Font();
            while ($myrow = db_fetch($trans)) {
                if ($myrow['amount'] > 0.0) {
                    array_push($deposit_on_transit, $myrow);
                    continue;
                }

                $rep->TextCol(0, 1, $systypes_array[$myrow["type"]]);
                $rep->TextCol(1, 2, $myrow['trans_no']);
                $rep->TextCol(2, 3, $myrow['ref']);
                $rep->DateCol(3, 4, $myrow["trans_date"], true);
                $rep->TextCol(4, 5, payment_person_name($myrow["person_type_id"], $myrow["person_id"], false));

                $rep->AmountCol(5, 6, abs($myrow['amount']), $dec);
                $total_credit += abs($myrow['amount']);

                $rep->TextCol(6, 7, $myrow['memo_']);
                $rep->NewLine();
                if ($rep->row < $rep->bottomMargin + $rep->lineHeight) {
                    $rep->Line($rep->row - 2);
                    $rep->NewPage();
                }
            }
            // Print totals for the debit and credit columns.
            $rep->Line($rep->row);
            $rep->NewLine();
            $rep->TextCol(0, 5, _("Total  outstanding Checks "));
            $rep->AmountCol(5, 6, $total_credit, $dec);
            $rep->Line($rep->row - 5);
            $rep->NewLine(2);
            $rep->NewLine(2);

            $rep->Line($rep->row);
            $rep->Font('bold');
            $rep->TextCol(0, 7, _('Add: Deposits in transit'));
            $rep->Line($rep->row + 15);
            $rep->NewLine(2);
            $rep->Font();
            foreach ($deposit_on_transit as $myrow) {
                $rep->TextCol(0, 1, $systypes_array[$myrow["type"]]);
                $rep->TextCol(1, 2, $myrow['trans_no']);
                $rep->TextCol(2, 3, $myrow['ref']);
                $rep->DateCol(3, 4, $myrow["trans_date"], true);
                $rep->TextCol(4, 5, payment_person_name($myrow["person_type_id"], $myrow["person_id"], false));

                $rep->AmountCol(5, 6, abs($myrow['amount']), $dec);
                $total_debit += abs($myrow['amount']);

                $rep->TextCol(6, 7, $myrow['memo_']);
                $rep->NewLine();
                if ($rep->row < $rep->bottomMargin + $rep->lineHeight) {
                    $rep->Line($rep->row - 2);
                    $rep->NewPage();
                }
            }
            $rep->Line($rep->row);
            $rep->NewLine();
            $rep->TextCol(0, 5, _("Total  Deposits in transit "));
            $rep->AmountCol(5, 6, $total_debit, $dec);
            $rep->Line($rep->row);
            $rep->NewLine(2);
            $rep->NewLine();
        }

        // Print totals for the debit and credit columns.
        $rep->Font('bold');
        $rep->TextCol(0, 5, _("Calculated Reconciled Balance"));
        $rep->AmountCol(5, 6, $reconciled - $total_credit + $total_debit, $dec);
        $rep->NewLine(2);

//        $rep->Font('bold');
//        $rep->TextCol(0, 5, _("Book Balance"));
//        $rep->AmountCol(5, 6, $book_balance, $dec);
//        $rep->Font();
//        $rep->NewLine(2);
//
//        $difference = $book_balance - $reconciled;
//
//        // Reco Difference
//        $rep->Font('bold');
//        $rep->TextCol(0, 5, _("Difference"));
//        $rep->AmountCol(5, 6, abs($difference), $dec);
//        $rep->Font();
//        $rep->NewLine(2);

        $rep->Line($rep->row  + 15);
        $rep->NewLine(2, 1);
    }
    $rep->End();
}
